Entity/Address.php
<?php

declare(strict_types=1);

namespace Comsa\SuluShoppingCart\Entity;

use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\Table;
use JMS\Serializer\Annotation\ExclusionPolicy;
use JMS\Serializer\Annotation\Expose;

#[
    Entity(),
    Table(name: "comsa_sc_addresses"),
    ExclusionPolicy("all")
]
class Address {
    #[
        Id(),
        GeneratedValue(strategy: "AUTO"),
        Column(type: Types::INTEGER),
        Expose()
    ]
    private ?int $id;

    #[
        Column(type: Types::STRING, length: 255),
        Expose()
    ]
    private ?string $street = null;

    #[
        Column(type: Types::STRING, length: 15),
        Expose()
    ]
    private ?string $streetNumber = null;

    #[
        Column(type: Types::STRING, length: 15),
        Expose()
    ]
    private ?string $postal = null;

    #[
        Column(type: Types::STRING, length: 255),
        Expose()
    ]
    private ?string $city = null;

    #[
        Column(type: Types::STRING, length: 2),
        Expose()
    ]
    private ?string $country = null;

    public function getId(): ?int {
        return $this->id;
    }

    public function getStreet(): ?string {
        return $this->street;
    }

    public function setStreet(string $street): self {
        $this->street = $street;

        return $this;
    }

    public function getStreetNumber(): ?string {
        return $this->streetNumber;
    }

    public function setStreetNumber(string $streetNumber): self {
        $this->streetNumber = $streetNumber;

        return $this;
    }

    public function getPostal(): ?string {
        return $this->postal;
    }

    public function setPostal(string $postal): self {
        $this->postal = $postal;

        return $this;
    }

    public function getCity(): ?string {
        return $this->city;
    }

    public function setCity(string $city): self {
        $this->city = $city;

        return $this;
    }

    public function getCountry(): ?string {
        return $this->country;
    }

    public function setCountry(string $country): self {
        $this->country = $country;

        return $this;
    }

    public function getAddress() : string {
        return sprintf("%s %s, %s %s", $this->getStreet(), $this->getStreetNumber(), $this->getPostal(), $this->getCity());
    }
}

Entity/CartItem.php
<?php

declare(strict_types=1);

namespace Comsa\SuluShoppingCart\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\DiscriminatorColumn;
use Doctrine\ORM\Mapping\DiscriminatorMap;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\InheritanceType;
use Doctrine\ORM\Mapping\InverseJoinColumn;
use Doctrine\ORM\Mapping\JoinColumn;
use Doctrine\ORM\Mapping\JoinTable;
use Doctrine\ORM\Mapping\ManyToMany;
use Doctrine\ORM\Mapping\ManyToOne;
use Doctrine\ORM\Mapping\Table;
use JMS\Serializer\Annotation\ExclusionPolicy;
use JMS\Serializer\Annotation\Expose;

#[
    Entity(),
    InheritanceType("SINGLE_TABLE"),
    DiscriminatorColumn(name: "discr", type: Types::STRING),
    DiscriminatorMap([
        "baseCartItems" => "Comsa\SuluShoppingCart\Entity\CartItem",
        "customCartItem" => "App\Entity\CartItem"
    ]),
    Table(name: "comsa_sc_cart_items"),
    ExclusionPolicy("all")
]
class CartItem {
    #[
        Id(),
        GeneratedValue(strategy: "AUTO"),
        Column(type: Types::INTEGER),
        Expose()
    ]
    private ?int $id;

    #[
        ManyToOne(targetEntity: "Comsa\SuluShoppingCart\Entity\Cart", inversedBy: "items", cascade: ["remove"]),
        JoinColumn(onDelete: "CASCADE"),
        Expose()
    ]
    private ?Cart $cart;

    #[
        ManyToOne(targetEntity: "Comsa\SuluShoppingCart\Entity\Product", inversedBy: "cartItems"),
        Expose()
    ]
    private ?Product $product;

    #[
        Column(type: Types::STRING, nullable: true),
        Expose()
    ]
    private ?string $uuid;

    #[
        Column(type: Types::INTEGER),
        Expose()
    ]
    private ?int $quantity = 1;

    #[
        Column(type: Types::STRING),
        Expose()
    ]
    private ?string $title;

    #[
        ManyToMany(targetEntity: "Comsa\SuluShoppingCart\Entity\Option"),
        JoinTable(name: "comsa_sc_cart_item_options"),
        JoinColumn(name: "cart_item_id", referencedColumnName: "id"),
        InverseJoinColumn(name: "option_id", referencedColumnName: "id"),
        Expose()
    ]
    private ArrayCollection|Collection|array $options;

    #[
        Column(type: Types::DECIMAL, precision: 10, scale: 2),
        Expose()
    ]
    private float $price;

    public function __construct() {
        $this->options = new ArrayCollection();
    }

    public function getId(): ?int {
        return $this->id;
    }

    public function getUuid(): ?string {
        return $this->uuid;
    }

    public function setUuid(string $uuid): self {
        $this->uuid = $uuid;

        return $this;
    }

    public function getQuantity(): ?int {
        return $this->quantity;
    }

    public function setQuantity(int $quantity): self {
        $this->quantity = $quantity;

        return $this;
    }

    public function increaseQuantity(int $quantity): self {
        $this->quantity += $quantity;

        return $this;
    }

    public function getCart(): ?Cart {
        return $this->cart;
    }

    public function setCart(?Cart $cart): self {
        $this->cart = $cart;

        return $this;
    }

    public function getTitle(): ?string {
        return $this->title;
    }

    public function setTitle(string $title): self {
        $this->title = $title;

        return $this;
    }

    public function getPrice(): ?float {
        return $this->price;
    }

    public function setPrice(float $price): self {
        $this->price = $price;

        return $this;
    }

    public function getTotal(): float|int {
        return $this->getQuantity() * $this->getPrice();
    }

    public function getProduct(): ?Product {
        return $this->product;
    }

    public function setProduct(?Product $product): self {
        $this->product = $product;

        return $this;
    }

    public function getOptions(): ?Collection {
        return $this->options;
    }

    public function setOptions($options): self {
        $this->options = $options;

        return $this;
    }

    public function addOption(Option $option): self {
        if (!$this->options->contains($option)) {
            $this->options->add($option);
        }

        return $this;
    }

    public function removeOption(Option $option): self {
        if ($this->options->contains($option)) {
            $this->options->removeElement($option);
        }

        return $this;
    }

    public function getSingleOption(): ?Option {
        if (!$this->getOptions()->isEmpty()) {
            return $this->getOptions()->first();
        } else {
            return null;
        }
    }

    public function setSingleOption(Option $option): self {
        $this->addOption($option);

        return $this;
    }
}

Resources/views/add-to-cart.html.twig
{% form_theme form with ['bootstrap_4_layout.html.twig'] %}

{% set flashes = app.flashes('payFirst') %}
{% if flashes %}
  {% for message in flashes %}
    <div class="alert alert-danger" role="alert">
      {{ message|raw }}
    </div>
  {% endfor %}
{% else %}
  {{ form_start(form) }}
  <div class="row align-items-end mb-5 mb-md-0">
    <div class="col-12">
      {{ form_rest(form) }}
    </div>
    <div class="col">

        <div class="form-group">
          <button class="btn btn-primary mb-0" type="submit">{{ 'comsa_sulu_shopping_cart.add_to_cart'|trans }}</button>
        </div>
    </div>
  </div>
  {{ form_end(form) }}
{% endif %}

Resources/views/cart-small.html.twig
{% set cart = cart() %}
<button class="btn btn-primary toggle-cart">{{ 'comsa_sulu_shopping_cart.show_shopping_cart'|trans }}</button>
<div class="cart-small" style="display: none;">
  <div class="shopping-cart-title-wrapper">
    <strong>{{ 'comsa_sulu_shopping_cart.shopping_cart'|trans }}</strong>
  </div>
  {% if cart.items|length > 0 %}
    <table class="table">
      <thead>
      <tr>
        <th>{{ 'comsa_sulu_shopping_cart.product'|trans }}</th>
        <th>x</th>
        <th>{{ 'comsa_sulu_shopping_cart.total'|trans }}</th>
        <th></th>
      </tr>
      </thead>
      <tbody>
      {% for item in cart.items %}
        <tr>
          <td>{{ item.title }}</td>
          <td>{{ item.quantity }}</td>
          <td>{{ item.total|price }}</td>
          <td><a href="{{ path('comsa_sulu_shopping_cart_delete_item', {'id': item.id}) }}" class="text-danger"><i class="fas fa-trash"></i></a></td>
        </tr>
      {% endfor %}
      </tbody>
      <tfoot>
      {% if cart.shippingMethod %}
        <tr>
          <th colspan="2" class="text-right">{{ 'comsa_sulu_shopping_cart.shipping'|trans }} ({{ cart.shippingMethod.name }})</th>
          <td colspan="2">{{ cart.shippingMethod.price|price }}</td>
        </tr>
      {% endif %}
      {% if cart.paymentMethod %}
        <tr>
          <th colspan="2" class="text-right">{{ 'comsa_sulu_shopping_cart.payment_method'|trans }} ({{ cart.paymentMethod.name }})</th>
          <td colspan="2">{{ cart.paymentMethod.price|price }}</td>
        </tr>
      {% endif %}
      <tr>
        <th colspan="2" class="text-right">{{ 'comsa_sulu_shopping_cart.total'|trans }}</th>
        <td colspan="2">{{ cart.total|price }}</td>
      </tr>
      </tfoot>
    </table>
    <a href="{{ path('comsa_sulu_shopping_cart') }}" class="btn btn-primary">{{ 'comsa_sulu_shopping_cart.go_to_shopping_cart'|trans }}</a>
  {% else %}
    <p>{{ 'comsa_sulu_shopping_cart.cart_is_empty'|trans }}</p>
  {% endif %}
</div>

Resources/views/cart.html.twig
{% extends 'base.html.twig' %}
{% block content %}
  <div class="container pt-2">
    <div class="row">
      <div class="col-12">
        <a href="{{ backUrl }}" class="btn btn-primary my-3">< {{ 'comsa_sulu_shopping_cart.back'|trans }}</a>
        {% include '@SuluShoppingCart/partials/product-table.html.twig' %}
      </div>
    </div>
    <div class="row">
      <div class="col-12 text-right">
        {% if cart %}
          <a href="{{ path('comsa_sulu_shopping_cart_create_customer') }}" class="btn btn-primary">{{ 'comsa_sulu_shopping_cart.continue'|trans }}</a>
        {% endif %}
      </div>
    </div>
  </div>
{% endblock %}

Resources/views/create-customer.html.twig
{% extends 'base.html.twig' %}
{% form_theme form with ['bootstrap_4_layout.html.twig'] %}
{% block content %}
  <div class="container customer-form-wrapper">
    <div class="col-md-8 offset-md-2">
      {{ form_start(form) }}
      <h2 class="text-center">{{ 'comsa_sulu_shopping_cart.contact_information'|trans }}</h2>

      <div class="form-row">
        <div class="form-group col-12 col-md-6">
          {{ form_row(form.firstName) }}
        </div>
        <div class="form-group col-12 col-md-6">
          {{ form_row(form.lastName) }}
        </div>
      </div>

      <div class="form-row">
        <div class="form-group col-12 col-md-6">
          {{ form_row(form.email) }}
        </div>
        <div class="form-group col-12 col-md-6">
          {{ form_row(form.phoneNumber) }}
        </div>
      </div>

      <h2 class="text-center mt-3">{{ 'comsa_sulu_shopping_cart.address'|trans }}</h2>
      {# {{ form_row(form.billingAddress) }} #}
      <div class="form-row">
        <div class="col-12 col-md-9 form-group">
          {{ form_row(form.billingAddress.street) }}
        </div>
        <div class="col-12 col-md-3 form-group">
          {{ form_row(form.billingAddress.streetNumber) }}
        </div>
      </div>
      <div class="form-row">
        <div class="col-12 col-md-2 form-group">
          {{ form_row(form.billingAddress.postal) }}
        </div>
        <div class="col-12 col-md-5 form-group">
          {{ form_row(form.billingAddress.city) }}
        </div>
        <div class="col-12 col-md-5 form-group">
          {{ form_row(form.billingAddress.country) }}
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-12">
          <p><label for="toggle-shipping"><input type="checkbox"
                                                 id="toggle-shipping"> {{ 'comsa_sulu_shopping_cart.alternative_shipping_address'|trans }}
            </label></p>
        </div>
      </div>
      <div style="display: none;" id="toggle-shipping-container">
        <div class="form-row d-flex">
          <div class="col-12 col-md-9 form-group">
            {{ form_row(form.shippingAddress.street) }}
          </div>
          <div class="col-12 col-md-3 form-group">
            {{ form_row(form.shippingAddress.streetNumber) }}
          </div>
        </div>
        <div class="form-row d-md-flex">
          <div class="col-12 col-md-2 form-group">
            {{ form_row(form.shippingAddress.postal) }}
          </div>
          <div class="col-12 col-md-5 form-group">
            {{ form_row(form.shippingAddress.city) }}
          </div>
          <div class="col-12 col-md-5 form-group">
            {{ form_row(form.shippingAddress.country) }}
          </div>
        </div>
      </div>
      {{ form_rest(form) }}
      <button type="submit" class="btn btn-primary">{{ 'comsa_sulu_shopping_cart.continue'|trans }}</button>
      {{ form_end(form) }}
    </div>
  </div>
{% endblock %}

Resources/views/create-mandate.html.twig
{% extends 'base.html.twig' %}
{% form_theme form with ['bootstrap_4_layout.html.twig'] %}
{% block content %}
  <div class="container customer-form-wrapper">
    <div class="col-md-8 offset-md-2">
      {{ form_start(form) }}
      <h2 class="text-center">{{ 'comsa_sulu_shopping_cart.consumer_information'|trans }}</h2>

      <div class="form-group col-12">
        {{ form_row(form.consumerAccount) }}
      </div>
      <div class="form-group col-12">
        {{ form_row(form.consumerBIC) }}
      </div>
      <div class="form-group col-12">
        {{ form_row(form.permission) }}
      </div>
      <button type="submit" class="btn btn-primary">{{ 'comsa_sulu_shopping_cart.continue'|trans }}</button>
      {{ form_end(form) }}
    </div>
  </div>
{% endblock %}

Resources/views/overview.html.twig
{% extends 'base.html.twig' %}
{% form_theme form with ['bootstrap_4_layout.html.twig'] %}
{% block content %}
  {% set customer = cart.customer %}
  <div class="container">
    <h1>{{ 'comsa_sulu_shopping_cart.order_overview'|trans }}</h1>
    {% include '@SuluShoppingCart/partials/product-table.html.twig' %}
    <h2>{{ 'comsa_sulu_shopping_cart.contact_information'|trans }}</h2>
    <dl>
      <dt>{{ 'comsa_sulu_shopping_cart.email'|trans }}</dt>
      <dd>{{ customer.email }}</dd>
      <dt>{{ 'comsa_sulu_shopping_cart.phone_number'|trans }}</dt>
      <dd>{{ customer.phoneNumber }}</dd>
      <dt>{{ 'comsa_sulu_shopping_cart.name'|trans }}</dt>
      <dd>{{ customer.firstName ~ ' ' ~ customer.lastName }}</dd>
    </dl>
    <div class="row">
      <div class="col-md-6">
        <h3>{{ 'comsa_sulu_shopping_cart.billing_address'|trans }}</h3>
        {% include '@SuluShoppingCart/partials/address.html.twig' with {'address': customer.billingAddress } %}
      </div>
      <div class="col-md-6">
        <h3>{{ 'comsa_sulu_shopping_cart.shipping_address'|trans }}</h3>
        {% include '@SuluShoppingCart/partials/address.html.twig' with {'address': customer.shippingAddress|default(customer.billingAddress) } %}
      </div>
    </div>

    {{ form_start(form) }}
    {{ form_rest(form) }}
    <button type="submit" class="btn btn-primary">{{ 'comsa_sulu_shopping_cart.place_order'|trans }}</button>
    {{ form_end(form) }}
  </div>
{% endblock %}

Resources/views/select-payment.html.twig
{% extends 'base.html.twig' %}
{% form_theme form with ['bootstrap_4_layout.html.twig', _self] %}
{% block content %}
  <div class="container">
    {{ form_start(form) }}
    {{ form_rest(form) }}
    <button type="submit" class="btn btn-primary">{{ 'comsa_sulu_shopping_cart.continue'|trans }}</button>
    {{ form_end(form) }}
  </div>
{% endblock %}

{% block _form_paymentMethod_widget %}
  <table class="table">
    <thead>
    <tr>
      <th>{{ 'comsa_sulu_shopping_cart.payment_method'|trans }}</th>
      <th>{{ 'comsa_sulu_shopping_cart.price'|trans }}</th>
    </tr>
    </thead>
    <tbody>
    {% for child in form.children %}
      <tr>
        <td>{{ form_widget(child) }}</td>
        <td>{{ form.vars.choices[child.vars.value].data.price|price }}</td>
      </tr>
    {% endfor %}
    </tbody>
  </table>
{% endblock %}

Resources/views/select-shipping.html.twig
{% extends 'base.html.twig' %}
{% form_theme form with ['bootstrap_4_layout.html.twig', _self] %}
{% block content %}
  <div class="container">
    {{ form_start(form) }}
    {{ form_rest(form) }}
    <button type="submit" class="btn btn-primary">{{ 'comsa_sulu_shopping_cart.continue'|trans }}</button>
    {{ form_end(form) }}
  </div>
{% endblock %}

{% block _form_shippingMethod_widget %}
  <table class="table">
    <thead>
      <tr>
        <th>{{ 'comsa_sulu_shopping_cart.shipping_method'|trans }}</th>
        <th>{{ 'comsa_sulu_shopping_cart.price'|trans }}</th>
      </tr>
    </thead>
    <tbody>
    {% for child in form.children %}
    <tr>
      <td>{{ form_widget(child) }}</td>
      <td>{{ form.vars.choices[child.vars.value].data.price|price }}</td>
    </tr>
    {% endfor %}
    </tbody>
  </table>
{% endblock %}